<template>
  <div
    class="tab-hover"
    :class="[
      isWidthCustomize
        ? 'w-[var(--default-width)] bg-background5 min-h-[260px] flex items-center top-[110px]'
        : 'bg-background5 min-h-[260px] flex items-center',
      'w-full absolute z-[11]',
      { 'header-full-width-content': isFullIframe },
      isFeatureHover ? 'translate-y-0 top-[95px] isFeatureHover' : 'translate-y-[-101%] isNotFeatureHover',
      'transition-all duration-200 ease-in-out',
    ]"
    @mouseleave="onChangeProductFeature(false)"
  >
    <div
      :class="[
        isWidthCustomize
          ? 'w-[var(--default-width)] bg-background5'
          : 'min-w-[1200px] w-[1200px] left-0',
        'mx-auto',
      ]"
    >
      <lobby-black-product-feature-tab-hover
        v-if="selectedThemeName === 'black'"
        :feature-products="featureProducts"
        @update:is-feature-hover="(event: boolean)=>onChangeProductFeature(event)"
      />
      <swiper
        v-else-if="isLoopFeatureProduct"
        :key="componentKey"
        :loop="true"
        :slides-per-view="5"
        :navigation="isLoopFeatureProduct"
        :modules="modules"
      >
        <template v-for="product in featureProducts" :key="product.GameId">
          <swiper-slide class="items-center justify-center swiper-slide">
            <div
              v-if="product.LinkOption !== '' && product.GameId !== 73"
              class="pointer"
              :class="
                product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="
                auth
                  ? handleReloadRoute(
                      processingUrl(
                        product.LinkOption,
                        EnumEntranceLocation.Hover
                      )
                    )
                  : DialogOrRedirect()
              "
            >
              <div><product-feature-provider-logo :product="product" /></div>
            </div>
            <div
              v-else-if="product.GameId === 73"
              class="pointer"
              :class="
                product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="
                auth
                  ? handleGameEntryOpenWindow(
                      product,
                      375,
                      667,
                      EnumEntranceLocation.Hover
                    )
                  : DialogOrRedirect()
              "
            >
              <div><product-feature-provider-logo :product="product" /></div>
            </div>
            <div
              v-else
              class="pointer"
              :class="
                product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="
                auth
                  ? handleGameEntryOpenWindow(
                      product,
                      850,
                      850,
                      EnumEntranceLocation.Hover
                    )
                  : DialogOrRedirect()
              "
            >
              <div><product-feature-provider-logo :product="product" /></div>
            </div>
          </swiper-slide>
        </template>
      </swiper>
      <swiper
        v-else
        :slides-per-view="5"
        :modules="modules"
        class="grid justify-center my-wrapper provider-container-center"
      >
        <template v-for="product in featureProducts" :key="product.GameId">
          <swiper-slide style="width: fit-content !important">
            <div
              v-if="product.LinkOption !== '' && product.GameId !== 73"
              class="pointer"
              :class="
                product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="
                auth
                  ? handleReloadRoute(
                      processingUrl(
                        product.LinkOption,
                        EnumEntranceLocation.Hover
                      )
                    )
                  : DialogOrRedirect()
              "
            >
              <div><product-feature-provider-logo :product="product" /></div>
            </div>
            <div
              v-else-if="product.GameId === 73"
              class="pointer"
              :class="
                product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="
                auth
                  ? handleGameEntryOpenWindow(
                      product,
                      375,
                      667,
                      EnumEntranceLocation.Hover
                    )
                  : DialogOrRedirect()
              "
            >
              <div><product-feature-provider-logo :product="product" /></div>
            </div>
            <div
              v-else
              class="pointer"
              :class="
                product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
              "
              @click="
                auth
                  ? handleGameEntryOpenWindow(
                      product,
                      850,
                      850,
                      EnumEntranceLocation.Hover
                    )
                  : DialogOrRedirect()
              "
            >
              <div><product-feature-provider-logo :product="product" /></div>
            </div>
          </swiper-slide>
        </template>
      </swiper>
    </div>
  </div>
  <theme-common-login-dialog v-model="Dialog" />
</template>

<script lang="ts">
import _ from "lodash";
import { defineComponent, PropType, ref, computed } from "vue";
import { Pagination, Navigation } from "swiper";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import {
  handleReloadRoute,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import useProductFeature from "@/composables/useProductFeature";

export default defineComponent({
  name: "ProductFeatureTabHover",
  props: {
    isWidthCustomize: {
      type: Boolean,
      default: false,
    },
    isFeatureHover: {
      type: Boolean,
      default: false,
    },
    featureProducts: {
      type: Object as PropType<Array<IGame>>,
      required: true,
    },
    componentKey: {
      type: Number,
      default: 0,
    },
  },
  emits: ["update:isFeatureHover"],
  setup(prop, { emit }) {
    const route = useRoute();
    const router = useRouter();
    const Dialog = ref(false);
    const isLoopFeatureProduct = computed(
      () => prop.featureProducts?.length > 5
    );
    const onChangeProductFeature = (event: boolean) => {
      emit("update:isFeatureHover", event);
    };
    const { auth, processingUrl, selectedThemeName } = useProductFeature();

    const DialogOrRedirect = () => {
      onChangeProductFeature(false);
      router.push("/login");
    };
    const isFullIframe: Ref<boolean> = ref((
      _.find(["saba", "digi"], (item: string) =>
        _.includes(_.toLower(String(route.query.provider)), item)
      ) !== undefined || _.toLower(String(route.query.englishGameName)) === "sbosportsmodern") || 
      route.query.tab === "sports"
    );
    watch(route, () => {
      const providerCheck =
        _.find(["saba", "digi"], (item: string) =>
          _.includes(_.toLower(String(route.query.provider)), item)
        ) !== undefined;
        const isSBOModernDesktop = _.toLower(String(route.query.englishGameName)) === "sbosportsmodern";
        isFullIframe.value = providerCheck || isSBOModernDesktop || route.query.tab === "sports";  
    });
    return {
      auth,
      processingUrl,
      handleReloadRoute,
      isLoopFeatureProduct,
      EnumEntranceLocation,
      onChangeProductFeature,
      handleGameEntryOpenWindow,
      Dialog,
      selectedThemeName,
      DialogOrRedirect,
      modules: [Pagination, Navigation],
      isFullIframe,
    };
  },
});
</script>
<style lang="scss">
.bg-background5 {
  background: var(--background5, var(--background1));
}

.tab-hover .swiper.swiper-initialized .swiper-button-prev,
.tab-hover .swiper.swiper-initialized .swiper-button-next {
  background: var(--background5, var(--background1));
}

.swiper {
  width: 97.5%;
  overflow: unset;

  &.swiper-initialized {
    @mixin button-default {
      top: 0;
      color: var(--primary);
      padding: 15px;
      margin-top: 0;
      height: 100%;

      &:after {
        font-size: 20px;
      }
    }

    .swiper-button-prev {
      translate: -2px;
      background-color: var(--background1);
      left: -16px;
      @include button-default;
    }

    .swiper-button-next {
      translate: 2px;
      background-color: var(--background1);
      right: -16px;
      @include button-default;
    }

    .swiper-slide {
      display: inherit;
    }
  }
}
</style>
<style scope>
.provider-container-center .swiper-wrapper {
  justify-content: center;
}
</style>
